<template>
  <button
    class="button"
    :type="type"
    :class="classes"
    :disabled="disabled">
    <slot name="button-item"/>
  </button>
</template>

<script>
export default {
  name: 'AppButton',
  props: {
    type: {
      type: String,
      default: 'button',
    },
    // Массив классов, например ['_round', '_cut']
    classes: {
      type: Array,
      default() {
        return [];
      },
    },
    disabled: {
      type: Boolean,
      default: false,
    },
  },
};
</script>

<style lang="postcss">
  .button {
    display: inline-flex;
    justify-content: center;
    align-items: center;
    padding: 0 1.25rem;
    width: auto;
    min-height: var(--btn-height-regular);
    max-height: 100%;

    font-size: 0.875rem;
    font-weight: var(--font-weight-medium);
    line-height: 1;
    color: var(--btn-color);
    text-decoration: none;

    border: none;
    border-radius: 0.25rem;
    background-color: var(--btn-bg);

    outline: none;
    cursor: pointer;
    transition: background-color 0.1s var(--transition-easeOutQuad), color 0.1s var(--transition-easeOutQuad);

    .svgBasket,
    .svgInBasket {
      fill: var(--btn-svg-fill);
    }

    &:hover {
      background-color: var(--btn-hover-bg);
    }

    &:active, &:focus {
      background-color: var(--btn-active-bg);
    }

    & .button-item {
      display: block;
      white-space: nowrap;
      transition: inherit;

      &.-sorting-up {
        & > svg {
          transform: rotate(180deg);
        }
      }

      & > .svg.plus {
        display: inline-block;
        margin-right: 0.5rem;
      }

      &:not(:last-child) {
        padding-bottom: 2px;
      }
    }

    & .button-label {
      transition: inherit;
    }

    &.buttonLight {
      padding: 0 1.625rem;
      width: 100%;
      height: 1.875rem;
      min-height: 1.875rem;

      font-size: 0.75rem;
      line-height: 1.875rem;
      color: var(--btn-light-color);

      border-radius: 2rem;
      background-color: var(--btn-light-bg);

      .svg.svgArrowRight {
        margin-top: 0.125rem;
        margin-left: 0.375rem;
        fill: var(--fill-main);
      }

      &:hover {
        color: var(--btn-light-hover-color);
        background-color: var(--btn-light-hover-bg);
      }

      &:active, &:focus {
        color: var(--btn-light-active-color);
        background-color: var(--btn-light-active-bg);
      }
    }

    &.buttonOutline {
      border: 1px solid var(--border-color-main);
      background-color: var(--btn-outline-bg);
      box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);

      &:hover {
        border-color: var(--border-color-hover);
        background-color: var(--btn-outline-bg);
      }

      &:active, &:focus {
        border-color: var(--border-color-active);
        background-color: var(--btn-outline-bg);
      }
    }

    &.buttonOutlineColor {
      background-color: var(--btn-outline-bg);
      border: 1px solid var(--btn-bg);
      // box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);

      &:hover {
        background-color: var(--btn-outline-bg);
        border-color: var(--btn-hover-bg);
      }

      &:active, &:focus {
        background-color: var(--btn-outline-bg);
        border-color: var(--btn-active-bg);
      }
    }

    &.buttonAccent {
      font-weight: var(--font-weight-bold);
      color: var(--btn-accent-color);

      background-color: var(--btn-accent-bg);
      box-shadow: -3px 3px 1px rgba(0, 0, 0, 0.15);

      &:hover {
        background-color: var(--btn-accent-hover-bg);
      }

      &:active, &:focus {
        background-color: var(--btn-accent-active-bg);
      }
    }

    &.buttonCall {
      flex-direction: column;
      padding: 0 1.625rem;
      height: var(--btn-height-medium);
      font-size: 0.75rem;
      background-color: var(--bg-main);
      background-image: var(--btn-blue-gradient);

      & .button-label {
        padding-bottom: 4px;
        line-height: 1.16;
        color: var(--bg-main);
        &.-is-mobile {
          display: none;
        }
      }

      & .button-item {
        color: var(--btn-blue-color);
      }

      // &.-disabled,
      // &.-disabled:hover,
      // &.-disabled:active,
      // &.-disabled:focus,
      // &:disabled {
      //   & .button-label,
      //   & .button-item {
      //     color: var(--btn-disabled-color);
      //   }
      // }

      &.-open {

        & .button-label {
          display: none;
        }

        & .button-item {
          color: var(--bg-main);
          font-size: 0.875rem;
          font-weight: var(--font-weight-bold);
        }
      }
    }

    &.buttonChat {
      flex-direction: column;
      padding: 0 1.625rem;
      width: auto;
      height: var(--btn-height-medium);
      font-size: 0.75rem;
      font-weight: var(--font-weight-regular);
      line-height: 1.5;
      border: 1px solid var(--border-color-main);
      background-color: var(--bg-main);
      box-shadow: 0 1px 2px rgba(0, 0, 0, 0.2);

      .button-item {
        display: flex;
        align-items: center;
      }

      .button-label {
        display: block;
        padding-left: 0.5rem;
        color: var(--color-main);
        white-space: nowrap;

        &._online {
          width: 100%;
          color: var(--online-color);

          &:hover {
            color: var(--online-hover-color);
          }

          &:active, &:focus {
            color: var(--online-active-color);
          }
        }
      }

      .svg.cloud {
        width: 0.9375rem;
        height: 0.9375rem;
        fill: var(--offline-color);
        transition: fill 0.5s var(--transition-easeOutQuad);
      }

      &:hover {
        border-color: var(--border-color-hover);
      }

      &:active, &:focus {
        border-color: var(--border-color-active);
      }

      &.-online {
        & .svg.cloud {
          fill: var(--online-color);
        }

        &:hover {
          & .svg.cloud {
            fill: var(--online-hover-color);
          }
        }

        &:active, &:focus {
          & .svg.cloud {
            fill: var(--online-active-color);
          }
        }
      }

      //&.-disabled,
      //&.-disabled:hover,
      //&.-disabled:active,
      //&.-disabled:focus,
      //&:disabled {
      //  & .button-label,
      //  .button-label._online {
      //    color: var(--btn-disabled-color);
      //  }

      //  & .svg.cloud {
      //    fill: var(--offline-color);
      //  }
      //}
    }

    &.buttonMap {
      position: relative;
      padding: 0 1.625rem;

      font-size: 0.75rem;
      font-weight: var(--font-weight-medium);
      color: var(--color-main);

      border: 1px solid rgba(109, 109, 109, 0.14);
      background-size: cover;
      background-repeat: no-repeat;
      background-position: center;
      background-image: url("~assets/svg/redesign/bg-btn-map.jpg");
      overflow: hidden;

      .button-item {
        position: relative;
      }

      &:before {
        content: '';
        position: absolute;
        top: 0;
        width: 100%;
        height: 100%;
        background-color: rgba(255, 255, 255, 0);
        transition: background-color 0.5s var(--transition-easeOutQuad);
      }

      &:hover {
        &:before {
          background-color: rgba(255, 255, 255, 0.25);
        }
      }

      &:active, &:focus {
        &:before {
          background-color: rgba(255, 255, 255, 0.3);
        }
      }

      &.-disabled,
      &.-disabled:hover,
      &.-disabled:active,
      &.-disabled:focus,
      &:disabled {
        opacity: 1;
        background-image: none;
        background-color: var(--bg-dark);
        color: #cccccc;
        position: relative;

        .button-item {
          color: #cccccc;
          position: absolute;
          display: flex;
          width: 100%;
          height: 100%;
          justify-content: center;
          align-items: center;
          z-index: 1;
          line-height: 100%;
          vertical-align: middle;
        }
      }
    }

    &.buttonAsLink {
      padding: 0;
      height: auto;
      min-height: auto;
      color: var(--link-color);
      background-color: transparent;
      &:hover {
        color: var(--link-hover-color);
      }
      &:active, &:focus {
        color: var(--link-active-color);
      }
      &[disabled] {
        border: none;
      }

      &._light {
        color: var(--color-main-lightest);

        &:hover {
          color: var(--color-main-lighten);
        }

        &:active, &:focus {
          color: var(--color-main-light);
        }
      }
    }

    &.buttonLike {
      padding: 0;
      height: auto;
      min-height: auto;
      font-size: 0;
      background: none;

      .button-item {
        display: flex;
        align-items: center;
      }

      .svg {
        transition: fill 0.1s var(--transition-easeOutQuad);
        fill: var(--fill-hover);
      }

      &:hover, &:active, &:focus {
        .svg {
          fill: var(--link-color);
        }
      }
    }

    &._none-round {
      border-radius: 0;
    }

    &._cut-left {
      border-radius: 0 0.25rem 0.25rem 0;
    }

    &._cut-right {
      border-radius: 0.25rem 0 0 0.25rem;
    }

    &._blue {
      color: var(--bg-main);
      font-weight: var(--font-weight-medium);
      background-color: var(--bg-main);
      background-image: var(--btn-blue-gradient);
      transition: background-image 0.1s var(--transition-easeOutQuad);
      .svg {
        display: inline-block;
        margin-right: 0.5rem;
        width: 1rem;
        height: auto;
        vertical-align: middle;
        fill: var(--bg-main);
      }
      &:hover, &:active, &:focus {
        background-image: var(--btn-blue-gradient-hover);
      }
    }

    &._transparent {
      background-color: transparent;
      background-image: none;
      transition: none;

      &:hover, &:focus, &:active {
        background-color: transparent;
      }
    }

    &.-disabled,
    &.-disabled:hover,
    &.-disabled:active,
    &.-disabled:focus,
    &:disabled {
      opacity: 0.65;
      // font-weight: var(--font-weight-regular);
      // color: var(--btn-disabled-color);
      // border: var(--btn-disabled-border);
      // background-color: var(--btn-disabled-bg);
      // background-image: none;
      // box-shadow: none;
      // text-shadow: none;
      cursor: default;
      pointer-events: none;

      .svg {
        fill: var(--btn-disabled-svg-fill);
      }
      &.-hasPointerEvents {
        pointer-events: auto;
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      height: var(--btn-height-medium);
      font-size: 0.875rem;

      &.buttonChat {
        padding: 0 0.5rem;
        flex-shrink: 0;
        width: var(--btn-height-medium);
        min-width: var(--btn-height-medium);
        max-width: var(--btn-height-medium);
        .button-label {
          display: none;
        }
        .svg.cloud {
          width: 1.125rem;
          height: 1.125rem;
        }
      }
    }

    @media screen and (min-width: 981px){
      &.buttonMap {
        max-height: 1.875rem;
        min-height: 1.875rem;
        border-radius: 1.5rem;
      }
    }

    @media screen and (max-width: 980px) {
      min-height: var(--btn-mobile-min-height);
      font-size: 1rem;

      &.buttonChat {
        padding: 0 0.5rem;
        font-size: 0.875rem;
        flex-shrink: 0;
        width: var(--btn-mobile-min-height);
        min-width: var(--btn-mobile-min-height);
        max-width: var(--btn-mobile-min-height);
        .button-label {
          display: none;
        }
        .svg.cloud {
          width: 1.625rem;
          height: 1.625rem;
        }
      }

      &.buttonCall {
        position: relative;
        padding: 0 0.875rem;
        font-size: 0.875rem;
        .button-label {
          font-size: 0.875rem;
          &.__bold {
            font-size: 1rem;
          }
          &.-is-mobile {
            display: block;
          }
          &:not(-is-mobile) {
            display: none;
          }
        }
      }

      &.buttonLike {
        width: 2.5rem;
        height: 2.5rem;
        background-color: var(--bg-lightest);
        border: 1px solid var(--border-color-main);
        box-shadow: 0px 1px 2px rgba(0, 0, 0, 0.2);

        .svg {
          width: 1rem;
          height: auto;
        }
      }
    }
  }
</style>
